//---------------------------------------------------------------------------

#include <vcl.h>
#include <math.h>

#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
Graphics::TBitmap *Bmp=new Graphics::TBitmap;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormPaint(TObject *Sender)
{
  const OTS=20;
  Timer1->Enabled=false;
  Bmp->Height=ClientHeight;
  Bmp->Width=ClientWidth;
  TPen *Pn=Bmp->Canvas->Pen;
  TBrush *Br=Bmp->Canvas->Brush;
  TCanvas *C=Bmp->Canvas;
  Br->Color=TColor(RGB(0,0,0));
  C->FillRect(C->ClipRect);
  Br->Color=TColor(RGB(0,0,255));
  Pn->Color=clRed;
  Pn->Width=4;
  int a = ClientWidth/2-OTS;
  int b = ClientHeight/2-OTS;
  C->Ellipse(OTS,OTS,ClientWidth-OTS,ClientHeight-OTS);
  TDateTime t= TDateTime::CurrentTime();
  unsigned short hh, mm, ss, mils;
  t.DecodeTime(&hh,&mm,&ss,&mils);
  //
  int x0=ClientWidth/2;
  int y0=ClientHeight/2;
  int x, y;
  float f;
  f=(hh+mm/60.0)*M_PI/6.0;
  x=x0+(a-60)*sin(f);
  y=y0-(b-60)*cos(f);
  C->MoveTo(x0,y0);
  C->LineTo(x,y);
  //
  Pn->Color=clWhite;
  Pn->Width=3;
  f=(mm+ss/60.0)*M_PI/30.0;
  x=x0+(a-30)*sin(f);
  y=y0-(b-30)*cos(f);
  C->MoveTo(x0,y0);
  C->LineTo(x,y);
  //
  Pn->Color=clLime;
  Pn->Width=2;
  f=ss*M_PI/30.0;
  x=x0+(a-10)*sin(f);
  y=y0-(b-10)*cos(f);
  C->MoveTo(x0,y0);
  C->LineTo(x,y);
  Pn->Color=clYellow;
  for(int i=1;i<=60;i++){
    int ll;
    f=i*M_PI/30.0;
    x=x0+a*sin(f);
    y=y0-b*cos(f);
    Br->Color=clYellow;
    if((i%5)==0){
      ll=5;
      Br->Color=clWhite;
      C->TextOutA(x0+(a+15)*sin(f),y0-(b+15)*cos(f),IntToStr(i/5));
      Br->Color=clYellow;
    }else
      ll=2;
    C->Ellipse(x-ll,y-ll,x+ll,y+ll);

  }
  Br->Color=clYellow;
  C->Ellipse(x0-5,y0-5,x0+5,y0+5);
  Canvas->Draw(0,0,Bmp);
  Timer1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
OnPaint(0L);        
}
//---------------------------------------------------------------------------

